local chestsNames = {"wooden-chest", "iron-chest", "steel-chest", "logistic-chest-storage", "logistic-chest-passive-provider"}


script.on_event(defines.events.on_built_entity, function (event)
	entity_name = event.created_entity.name
	if tableContains(chestsNames, entity_name) and (global.GUI) then
		
		game.players[1].print ("entity name is ".. entity_name)
				mainHandler(event)
	end
end)


function mainHandler(event)
	local player_index = event.player_index or 1
	local entity = event.created_entity 
	if not (global) then game.players[1].print ("No global, sorry")	return end
	if not (global.GUI) then game.players[1].print ("No global.GUI, sorry")	return end
	if not (global.GUI[player_index]) then 
	game.players[1].print ("No global.GUI[player_index], sorry")
	return end
	
	if not (global.GUI[player_index].itemOrNothing) then 
	game.players[1].print ("No global.GUI[player_index].itemOrNothing, sorry")
	return end
	local itemOrNothing = global.GUI[player_index].itemOrNothing
	
	if itemOrNothing == "nothing" then 
		game.players[1].print ("From GUI: ".. itemOrNothing)
		return
	end
	
	local item = itemOrNothing -- its not a nothing, yay!
	game.players[1].print("must place chest with " .. item)
	addEntityToTable(entity, item)
end


function addEntityToTable(entity, item)
	if not global.entities then global.entities = {} end
	local ID = nextID()
	global.entities[ID] = {}
	global.entities[ID].type = chest
	global.entities[ID].entity = entity
	global.entities[ID].ID = ID -- some magick
	global.entities[ID].item = item
end


function nextID()
	if not global.ID then global.ID = 0 end
	local ID = global.ID
	ID = ID + 1
	global.ID = ID
	return ID
end


script.on_event(defines.events.on_tick, function (event)
	if not (game.tick % 120 == 0) then return end -- twice in second
	handler_on_tick()
	--game.players[1].print ("Tick #1")
	if not (global.entities) then return end
	for ID_chest, chest in pairs (global.entities) do
		fill_chest(ID_chest, chest.item)
	end
end)


function fill_chest(ID, item)
	if not (global.entities[ID]) then
		game.players[1].print ("No global.entities[ID], sorry")
		return
	end
	
	if not (global.entities[ID].entity.valid) then
		game.players[1].print (ID .. " - This entity was destroyed, sorry.")
		global.entities[ID] = nil
		game.players[1].print ("We still have " .. #global.entities .. " more.")
		return
	end
	
	local chest_inventory = global.entities[ID].entity.get_inventory(1)
	chest_inventory.clear()
	
	for l = 1, 2 do
	chest_inventory[l].set_stack{name = item, count = global.items[item].stack_size}
	end

end


function removeEntityFromTable(entity)
	local ID = tableContains(table, element).ID
	global.entities[ID] = nil
end


function tableContains(table, element)
  for _, value in pairs(table) do
    if value == element then
      return value
    end
	 if type(value) == "table" then
		local valueOrFalse = tableContains(value, element)
		if valueOrFalse then return value end
	 end
  end
  return false
end


-- delete all destroyed entities
script.on_event(defines.events.on_player_mined_item, function (event)
  local player = game.players[event.player_index]
  local item = event.item_stack
  player.remove_item{name = item.name, count = 1}
end)

