
local chest_size = 10


script.on_event(defines.events.on_player_created, function(event)
	if (#game.players <= 1) then
		game.show_message_dialog{text = {"msg-intro"}}
	end
end)



script.on_event(defines.events.on_player_mined_item, function (event)
  local player = game.players[event.player_index]
  local item = event.item_stack
  player.remove_item{name = item.name, count = 1}
end)

script.on_init(function()
  init_attack_data()
  make_item_list()
  make_item_chest()
end)

function getPowerArmorAndTechs(event)
	local player = game.players[event.player_index]
	
	player.force.research_all_technologies()

	player.insert{name="power-armor-mk2", count = 1}
	local p_armor = player.get_inventory(5)[1].grid
		p_armor.put({name = "fusion-reactor-equipment"})
		p_armor.put({name = "fusion-reactor-equipment"})
		p_armor.put({name = "fusion-reactor-equipment"})
		p_armor.put({name = "fusion-reactor-equipment"})
		p_armor.put({name = "exoskeleton-equipment"})
		p_armor.put({name = "exoskeleton-equipment"})
		p_armor.put({name = "energy-shield-mk2-equipment"})
		p_armor.put({name = "energy-shield-mk2-equipment"})
		p_armor.put({name = "personal-roboport-equipment"})
		p_armor.put({name = "night-vision-equipment"})
		p_armor.put({name = "battery-mk2-equipment"})
		p_armor.put({name = "battery-mk2-equipment"})

	player.insert{name="construction-robot", count = 10}
	player.insert{name="blueprint", count = 3}
	player.insert{name="deconstruction-planner", count = 1}
	player.insert{name="steel-axe", count = 10}
end


function make_item_list()
	if global.item_list == nil then 
		global.item_list = {}
		local i = 0
		for k, v in pairs (game.item_prototypes) do  
			i = i + 1
			global.item_list[i] = v
		end
		script.on_event(defines.events.on_tick, fill_chest)
	end
end


function make_item_chest(item) -- makes chests and adds to global table
	global.item_chest = {}
	for k = 1,6 do
		global.item_chest[k] = game.surfaces["nauvis"].create_entity{name = "logistic-chest-storage", position = {0, k}, force = game.forces.player}
		global.item_chest[k].minable = true
		global.item_chest[k].destructible = false
	end
	script.on_event(defines.events.on_tick, fill_chest(item))
end


function fill_chest(item)
	if not (game.tick % 30 == 0) then return end
	local m = 1
	for k, v in pairs(global.item_list) do
		--if k % 60 == game.tick % 60 then
			local i = math.ceil(k/chest_size) 	-- which chest
			local l = k - ((i-1)*chest_size) 	-- which cell
			if i == m then
				global.item_chest[i].get_inventory(1).clear()
				m = m + 1
			end
			global.item_chest[i].get_inventory(1)[l].set_stack{name = v.name, count = v.stack_size}
		--end 
	end
end


function addEntityToTable(entity)
	if not global.entities then global.entities = {} end
	local ID = nextID()
	global.entities[ID] = {}
	global.entities[ID].entity = entity
	global.entities[ID].entity.ID = ID -- some magick
end


function nextID()
	if not global.ID then global.ID = 0 end
	local ID = global.ID
	ID = ID + 1
	global.ID = ID
	return ID
end


function removeEntityFromTable(entity)
	local ID = tableContains(table, element).ID
	global.entities[ID] = nil
end


function tableContains(table, element)
  for _, value in pairs(table) do
    if value == element then
      return value
    end
	 if type(value) == "table" then
		local valueOrFalse = tableContains(value, element)
		if valueOrFalse then return value end
	 end
  end
  return false
end



























